;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;  IRCWX Chatroom Lister  ;;;;;;;
;;;;;;;;;;         Room Lister v 1.0             ;;;;;;;;;;
;;;;;;;;;;             by err0r                  ;;;;;;;;;;
;;;;;;;;;;        http://www.tg007.net           ;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;   Report any errors or suggestions    ;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

alias openroomlister { dialog -md roomlister roomlister | hmake searchit 10 | halt }
dialog roomlister {
  title "Roomlister"
  size -1 -1 760 370
}
on *:dialog:roomlister:init:*:{
  set -eu1 %justopen on
  dcx Mark $dname roomlister_alias
  ;Text
  xdialog -c $dname 10 text 0 0 $dialog($dname).cw 22, noformat
  xdid -t $dname 10 $chr(9) ircwx Room Lister
  xdid -f $dname 10 +b ansi 12 Tahoma
  ;Line
  xdialog -c $dname 11 line 0 23 $dialog($dname).cw 5
  xdialog -c roomlister 1 listview 0 50 $dialog($dname).cw 270, report showsel fullrow tooltip singlesel
  xdialog -c roomlister 2 comboex 624 25 130 316, dropdown
  xdid -w roomlister 1 +n 0 $Mircdirircwx-roomlister\rmicon_srv.ico
  xdid -w roomlister 1 +n 0 $Mircdirircwx-roomlister\rmicon_user.ico
  xdid -w roomlister 1 +n 0 $Mircdirircwx-roomlister\room.ico
  xdid -t roomlister 1 +l 0 310 Roomname $chr(9) +c 0 60 Users $chr(9) +c 0 80 Language $chr(9) +l 0 206 Topic
  ;comboex
  xdid -a roomlister 2 0 0 0 0 0 Select a Category
  xdid -a roomlister 2 0 0 0 0 0 All Rooms
  xdid -a roomlister 2 0 0 0 0 0 Computing
  xdid -a roomlister 2 0 0 0 0 0 Fun 'n' Games
  xdid -a roomlister 2 0 0 0 0 0 City Chats
  xdid -a roomlister 2 0 0 0 0 0 General
  xdid -a roomlister 2 0 0 0 0 0 Interests
  xdid -a roomlister 2 0 0 0 0 0 LifeStyles
  xdid -a roomlister 2 0 0 0 0 0 Peers
  xdid -a roomlister 2 0 0 0 0 0 Religion
  xdid -a roomlister 2 0 0 0 0 0 Romance
  xdid -a roomlister 2 0 0 0 0 0 Roleplay
  xdid -c roomlister 2 1
  xdialog -c roomlister 3 statusbar -1 -1 -1 -1 tooltips notheme
  xdid -l roomlister 3 2 120 -1 
  xdid -w roomlister 3 + 0 $Mircdirircwx-roomlister\room.ico
  xdid -w roomlister 3 + 0 $Mircdirircwx-roomlister\infom.ico
  xdid -t roomlister 3 1 +fn 0
  xdid -t roomlister 3 2 +fn 1 Total Rooms: 0
  xdid -t roomlister 3 3 +fn 2 Category: n/a
  ;text
  xdialog -c roomlister 5 text 9 27 195 16, center noformat
  ;search box
  xdialog -c roomlister 8 edit 4 326 670 21
  ;search button
  xdialog -c $dname 9 button 680 324 76 25
  xdid -l $dname 9 16
  xdid -w $dname 9 +n 0 $Mircdirircwx-roomlister\find.ico
  xdid -t $dname 9 Find/Next
  unset %room.*
  unset %f.line
}
on *:dialog:roomlister:close:*: { unset %room.* | unset %f.line | hfree searchit * }
alias roomlistericon {
  if (rmicon_srv isin $1-) { return 1 }
  elseif (rmicon_user isin $1-) { return 2 }
  else { return 3 }
}
alias roomlister_alias {
  if ($2 == hsclick) && ($3 == 1) { 
    if ($4 == 1) { xdid -z $1 1 +a $4 }
    elseif ($4 == 2) { xdid -z $1 1 +nd $4  } 
    else { xdid -z $1 1 +a $4  } 
  }
  if ($2 == dclick) && ($3 == 1) { join $chr(37) $+ $chr(35) $+ $replace($xdid(roomlister, 1, 1).seltext,$chr(32),\b,$chr(160),\b) }
  if ($2 == rclick) { if ($3 == 1) && ($xdid(roomlister,1,1).seltext) { roomlistpopup } }
  if ($2 == sclick) {
    if ($3 == 2) { if ($xdid(roomlister,2).seltext == Select a Category) { halt } | set -e %room.category $roomcat($xdid(roomlister,2).seltext) | xdid -r roomlister 1 | xdid -t roomlister 3 1 +p 0 Total Rooms: 0 | listrooms }
    if ($3 == 9) { 
      if ($hget(searchit,previousSearch) != $xdid(roomlister,8).text) { hadd -m searchit previousSearch $xdid(roomlister,8).text | set %f.line 1 }
      else { set -e %f.line $calc(%f.line +1) }
      var %nextLine $xdid(roomlister,1,$chr(9) * $+ $xdid(roomlister,8).text $+ * $chr(9),W,0,%f.line).find
      if (%nextLine != $null) { /xdid -c roomlister 1 %nextLine | /xdid -V roomlister 1 %nextLine  }
      else { $input(End of search,uodw,Attention!) | set -e %f.line 1 }
    }
  }
}
on *:SIGNAL:Xpopup-*: {
  var %xrm $gettok($signal, 2-, 45)
  if ($1 == 0) { return }
  if (%xrm == roomoptions) {
    if ($1 == 1) { join $chr(37) $+ $chr(35) $+ $replace($xdid(roomlister, 1, 1).seltext,$chr(32),\b,$chr(160),\b) }
    if ($1 == 3) { url $+(http://www.evolutionchat.co/c/?cn=,$xdid(roomlister, 1, 1).seltext) }
    if ($1 == 4) { clipboard $+(http://www.evolutionchat.co/c/?cn=,$xdid(roomlister, 1, 1).seltext) }
  }
}
alias roomlistpopup {
  if ($xpopup(roomoptions).ismenu) xpopup -d roomoptions
  xpopup -c roomoptions normal
  xpop -a roomoptions 3 $chr(9) + 4 0 Copy Link
  xpop -a roomoptions 2 $chr(9) + 3 0 Join Browser
  xpop -a roomoptions 3 $chr(9) +g 4 0 -
  xpop -a roomoptions 1 $chr(9) + 1 0 Join mIRC
  xpopup -s roomoptions +v $Mouse.dx $Mouse.dy
}
alias listrooms {
  ;if ($status != connected) { halt }
  if (!$dialog(roomlister)) { dialog -m roomlister roomlister }
  if ($1) { set %room.category $1 }
  if (!%room.number) { set -e %room.number 1 }
  if (!%room.total) { set -e %room.total 1 }
  if (!%room.category) { set -e %room.category cp  }
  if (!%room.number) { set -e %room.number 1 }
  unset %rlroom.*
  ;xdid -r roomlister 1
  roomload
  sockclose roomlister | sockopen roomlister www.evolutionchat.co 80
}

;;; Socket 
on *:sockopen:roomlister: { 
  if ($sockerr) { sockclose $sockname | halt }
  set -e %room.nextpage $calc(%room.number +1)
  if (%room.category == All Rooms) { sockwrite -n $sockname GET /ChannelsList/ $+ %room.number HTTP/1.1 }
  else { sockwrite -n $sockname GET /ChannelsList/ $+ %room.category $+ / $+ %room.number HTTP/1.1 }
  sockwrite -n $sockname Host: www.evolutionchat.co
  sockwrite -n $sockname $crlf
  xdid -t roomlister 3 3 +fn 2 Category: $roomcatr(%room.category)
}
on *:sockread:roomlister: {
  if ($sockerr > 0) return | var %rl | sockread %rl
  tokenize 32 %rl
  if ($regex($1-,/<td class=\"cl_img\">/ig)) {
    set -eu2 %getrmimage on
  }
  if (%getrmimage == on) && ($regex($1-,/<img src=\"/Content/images/(.*?)\" alt=\"\" \/>/ig)) {
    set -e %rlroom.icon $roomlistericon($regml(1))
    unset %getrmimage
  }
  if ($regex($1-,/<td class=\"cl_channel\"><a href=(.*?)>(.*?)<\/a><\/td>/ig)) {
    unset %getrmimage
    set -e %rlroom.name $replace($regml(2),&#39;,')
  }
  if ($regex($1-,/<td class=\"cl_topic\" data-channeltopic>(.*?)<\/td>/ig)) {
    set -e %rlroom.topic $rmstrip($regml(1))
  }
  if ($regex($1-,/<td class=\"cl_count\">(.*?)<\/td>/ig)) {
    set -e %rlroom.count $regml(1)
  }
  if ($regex($1-,/<td class=\"cl_lang\">(.*?)<\/td>/ig)) {
    set -e %rlroom.lang $regml(1)
    poplist
  }
  if ($regex($1-,/<li class=\"mircpage\"><a href="\/ChannelsList\/(.*?)">(.*?)<\/a><\/li>/ig)) {
    set -e %room.lastnm $regml(2)
  }
  if ($regex($1,/<\/body>/)) { 
    if (%room.nextpage > %room.lastnm) || (!%room.lastnm) { sockclose $sockname | unset %room.* | roomdone }
    else { sockclose $sockname | inc %room.number | listrooms  }
  }
}  
alias poplist {
  xdid -a roomlister 1 0 0 + $iif(%rlroom.icon,%rlroom.icon,3) 0 0 0 0 0 %rlroom.name $chr(9) + 0 -1 -1 -1 %rlroom.count $chr(9) + 0 -1 -1 -1 $rmlanguage(%rlroom.lang) $chr(9) + 0 -1 -1 -1 %rlroom.topic
  xdid -t roomlister 3 2 +fn 1 Total Rooms: %room.total
  inc %room.total
  unset %rlroom.*
}
alias rmstrip {
  return $strip($remove($strip($regsubex($1-, /\[(?:style\x20.*?|/style)\]/gi,$null)),[br]))
}
alias roomload { if ($dialog(roomlister)) { xdid -b roomlister 1,2 | if ($xdialog(roomlister,6).isid) {  xdid -b roomlister 6 } | xdid -t roomlister 5 populating list please wait... } }
alias roomdone { if ($dialog(roomlister)) { xdid -e roomlister 1,2 | if ($xdialog(roomlister,6).isid) { xdid -e roomlister 6 } | xdid -t roomlister 5 complete! | .timer.roomdone -m 1 900 xdid -r roomlister 5 | unset %room.number | unset %room.total | unset %room.category | unset %room.name  } }
alias rmlanguage { return $replace($1,Deutsch,Dutch,Fran&ccedil;ais,French,Espa&ntilde;ol,Spanish,Português,Portugues,????????,Arabic) }
alias roomcatr { return $replacex($1,et,Entertainment,gn,General,cp,Computing,rm,Romance,pr,Peers,un,Unlisted,ge,City Chats,ii,Interests,lf,Lifestyles,ne,News & Politics,rl,Religion,rp,Roleplay,sp,Sport & Health,tn,Teens,dz,DangerZone,ea,Fun 'n' Games) }
alias roomcat { return $replacex($1,General,gn,Computing,cp,Romance,rm,Peers,pr,Unlisted,un,City Chats,ge,Entertainment,et,Interests,ii,Lifestyles,lf,News & Politics,ne,Religion,rl,Roleplay,rp,Sport & Health,sp,Teens,tn,DangerZone,dz,Fun 'n' Games,ea) }
